#!/usr/bin/env python

from wxPython.wx import *
import os, md5, pickle

[wxID_WXFRAME1, wxID_WXFRAME1BUTTON1, wxID_WXFRAME1BUTTON2, 
 wxID_WXFRAME1CHECKBOX1, wxID_WXFRAME1COMBOBOX1, wxID_WXFRAME1COMBOBOX2, 
 wxID_WXFRAME1GAUGE1, wxID_WXFRAME1LISTBOX1, wxID_WXFRAME1LISTBOX2, 
 wxID_WXFRAME1LISTBOX3, wxID_WXFRAME1LISTBOX4, wxID_WXFRAME1ONTOLOGYTREEVIEW, 
 wxID_WXFRAME1PANEL1, wxID_WXFRAME1STATICTEXT1, wxID_WXFRAME1STATICTEXT2, 
 wxID_WXFRAME1STATICTEXT3, wxID_WXFRAME1STATICTEXT4, wxID_WXFRAME1STATICTEXT5, 
 wxID_WXFRAME1STATICTEXT6, wxID_WXFRAME1STATICTEXT7, wxID_WXFRAME1STATICTEXT8, 
 wxID_WXFRAME1STATICTEXT9, wxID_WXFRAME1TEXTCTRL1, wxID_WXFRAME1TEXTCTRL2, 
 wxID_WXFRAME1TEXTCTRL3, 
] = map(lambda _init_ctrls: wxNewId(), range(25))

#ISA=u"urn:lsid:biomoby.org:objectrelation:isa"
#HAS=u"urn:lsid:biomoby.org:objectrelation:has"
#HASA=u"urn:lsid:biomoby.org:objectrelation:hasa"

class OntologyTreeModel:
    def __init__(self, client, setRange=None, setInc=None):
        from bioMoby import ServiceQuery
        
        self._ISARelations={}
        self.definitions={}
        self.relations={}
        self.inputServices={}
        self.outputServices={}
        self.url=client.url
        self.ns=client.ns
        
        objectNames=client.retrieveObjectNames()
        
        if setRange:
            setRange(len(objectNames.keys()))
        
        for objectName in objectNames.keys():
            if setInc:
                setInc()
            self.definitions[objectName]=client.retrieveObjectDefinition(objectName)
            self.relations[objectName]=self.definitions[objectName]["Relationship"]
            sq=ServiceQuery(inputObjects=[ ('', str(objectName), []) ])
            
            
            sl=client.findService(sq)
            self.inputServices[objectName]=[]
            for service in sl:
                self.inputServices[objectName].append(service.name)
            
            self.inputServices[objectName].sort()

            sq=ServiceQuery(outputObjects=[ ('', str(objectName), []) ])
            
            sl=client.findService(sq)
            self.outputServices[objectName]=[]
            for service in sl:
                self.outputServices[objectName].append(service.name)
            
            self.outputServices[objectName].sort()

            if "ISA" in self.relations[objectName]:
                obj=self.relations[objectName]["ISA"]
                obj=obj[0][1].split(":")
                obj=obj[len(obj)-1]
            else:
                obj="None"
        
            if obj in self._ISARelations:
                self._ISARelations[obj].append(objectName)
            else:
                self._ISARelations[obj]=[objectName]

    def __getitem__(self, key):
        return self._ISARelations[key]

    def keys(self):
        return self._ISARelations.keys()


class wxFrame1(wxFrame):
    def _init_ctrls(self, prnt):
        # generated method, don't edit
        wxFrame.__init__(self, id=wxID_WXFRAME1, name='', parent=prnt,
              pos=wxPoint(191, 101), size=wxSize(800, 600),
              style=wxSYSTEM_MENU | wxCAPTION | wxMINIMIZE_BOX,
              title='Object browser')
        self.SetClientSize(wxSize(800, 600))
        self.SetToolTipString('bioMoby objects browser')

        self.OntologyTreeview = wxTreeCtrl(id=wxID_WXFRAME1ONTOLOGYTREEVIEW,
              name='OntologyTreeview', parent=self, pos=wxPoint(8, 168),
              size=wxSize(336, 408), style=wxTR_HAS_BUTTONS,
              validator=wxDefaultValidator)
        EVT_TREE_SEL_CHANGED(self.OntologyTreeview,
              wxID_WXFRAME1ONTOLOGYTREEVIEW,
              self.OnOntologytreeviewTreeSelChanged)

        self.panel1 = wxPanel(id=wxID_WXFRAME1PANEL1, name='panel1',
              parent=self, pos=wxPoint(352, 16), size=wxSize(424, 568),
              style=wxTAB_TRAVERSAL)

        self.staticText1 = wxStaticText(id=wxID_WXFRAME1STATICTEXT1,
              label='Description', name='staticText1', parent=self.panel1,
              pos=wxPoint(16, 0), size=wxSize(70, 16), style=0)

        self.textCtrl1 = wxTextCtrl(id=wxID_WXFRAME1TEXTCTRL1, name='textCtrl1',
              parent=self.panel1, pos=wxPoint(16, 16), size=wxSize(400, 56),
              style=wxTE_READONLY | wxTE_MULTILINE, value='')

        self.staticText2 = wxStaticText(id=wxID_WXFRAME1STATICTEXT2,
              label='Contact Email', name='staticText2', parent=self.panel1,
              pos=wxPoint(16, 80), size=wxSize(90, 16), style=0)

        self.textCtrl2 = wxTextCtrl(id=wxID_WXFRAME1TEXTCTRL2, name='textCtrl2',
              parent=self.panel1, pos=wxPoint(16, 96), size=wxSize(400, 22),
              style=wxTE_READONLY, value='')

        self.staticText3 = wxStaticText(id=wxID_WXFRAME1STATICTEXT3,
              label='Authority URI', name='staticText3', parent=self.panel1,
              pos=wxPoint(16, 128), size=wxSize(90, 16), style=0)

        self.textCtrl3 = wxTextCtrl(id=wxID_WXFRAME1TEXTCTRL3, name='textCtrl3',
              parent=self.panel1, pos=wxPoint(16, 144), size=wxSize(400, 24),
              style=wxTE_READONLY, value='')

        self.staticText4 = wxStaticText(id=wxID_WXFRAME1STATICTEXT4,
              label='HAS', name='staticText4', parent=self.panel1,
              pos=wxPoint(16, 184), size=wxSize(40, 16), style=0)

        self.listBox1 = wxListBox(choices=[], id=wxID_WXFRAME1LISTBOX1,
              name='listBox1', parent=self.panel1, pos=wxPoint(16, 200),
              size=wxSize(400, 56), style=0, validator=wxDefaultValidator)

        self.staticText5 = wxStaticText(id=wxID_WXFRAME1STATICTEXT5,
              label='HASA', name='staticText5', parent=self.panel1,
              pos=wxPoint(16, 264), size=wxSize(60, 16), style=0)

        self.listBox2 = wxListBox(choices=[], id=wxID_WXFRAME1LISTBOX2,
              name='listBox2', parent=self.panel1, pos=wxPoint(16, 280),
              size=wxSize(400, 64), style=0, validator=wxDefaultValidator)

        self.staticText6 = wxStaticText(id=wxID_WXFRAME1STATICTEXT6,
              label='Services that take this data type as input:',
              name='staticText6', parent=self.panel1, pos=wxPoint(16, 352),
              size=wxSize(250, 16), style=0)

        self.listBox3 = wxListBox(choices=[], id=wxID_WXFRAME1LISTBOX3,
              name='listBox3', parent=self.panel1, pos=wxPoint(16, 368),
              size=wxSize(400, 64), style=0, validator=wxDefaultValidator)

        self.button1 = wxButton(id=wxID_WXFRAME1BUTTON1, label='Close',
              name='button1', parent=self.panel1, pos=wxPoint(336, 536),
              size=wxSize(80, 24), style=0)
        EVT_BUTTON(self.button1, wxID_WXFRAME1BUTTON1, self.OnButton1Button)

        self.staticText7 = wxStaticText(id=wxID_WXFRAME1STATICTEXT7,
              label='URL', name='staticText7', parent=self, pos=wxPoint(8, 16),
              size=wxSize(30, 16), style=0)

        self.staticText8 = wxStaticText(id=wxID_WXFRAME1STATICTEXT8, label='NS',
              name='staticText8', parent=self, pos=wxPoint(8, 56),
              size=wxSize(20, 16), style=0)

        self.button2 = wxButton(id=wxID_WXFRAME1BUTTON2,
              label='Retrieve objects', name='button2', parent=self,
              pos=wxPoint(8, 136), size=wxSize(120, 24), style=0)
        EVT_BUTTON(self.button2, wxID_WXFRAME1BUTTON2, self.OnButton2Button)

        self.gauge1 = wxGauge(id=wxID_WXFRAME1GAUGE1, name='gauge1',
              parent=self, pos=wxPoint(136, 136), range=100, size=wxSize(184,
              22), style=wxGA_HORIZONTAL, validator=wxDefaultValidator)

        self.staticText9 = wxStaticText(id=wxID_WXFRAME1STATICTEXT9,
              label='Services that take this data type as output:',
              name='staticText9', parent=self.panel1, pos=wxPoint(16, 440),
              size=wxSize(260, 16), style=0)

        self.listBox4 = wxListBox(choices=[], id=wxID_WXFRAME1LISTBOX4,
              name='listBox4', parent=self.panel1, pos=wxPoint(16, 456),
              size=wxSize(400, 72), style=0, validator=wxDefaultValidator)

        self.comboBox1 = wxComboBox(choices=[], id=wxID_WXFRAME1COMBOBOX1,
              name='comboBox1', parent=self, pos=wxPoint(8, 32),
              size=wxSize(312, 22), style=0,
              value='http://mobycentral.cbr.nrc.ca/cgi-bin/MOBY05/mobycentral.pl')
        self.comboBox1.SetLabel('')

        self.comboBox2 = wxComboBox(choices=[], id=wxID_WXFRAME1COMBOBOX2,
              name='comboBox2', parent=self, pos=wxPoint(8, 72),
              size=wxSize(312, 22), style=0,
              value='http://mobycentral.cbr.nrc.ca/MOBY/Central')
        self.comboBox2.SetLabel('')

        self.checkBox1 = wxCheckBox(id=wxID_WXFRAME1CHECKBOX1,
              label='Fetch data from cache (if there is any)', name='checkBox1',
              parent=self, pos=wxPoint(8, 104), size=wxSize(260, 24), style=0)
        self.checkBox1.SetValue(False)

    def __init__(self, parent):
        self._init_ctrls(parent)
        self.CenterOnScreen()
        self.gauge1.Hide()
        
        try:
            os.mkdir("%s/.objectBrowser"%os.environ['HOME'])
        except:
            pass
        
        try:
            fp=file("%s/.objectBrowser/.url"%os.environ['HOME'])
            for l in fp.readlines():
                self.comboBox1.Append(l.replace("\n",""))
            fp.close()
        except:
            fp=file("%s/.objectBrowser/.url"%os.environ['HOME'],"w")
            fp.write("http://mobycentral.cbr.nrc.ca/cgi-bin/MOBY05/mobycentral.pl")
            fp.close()
            self.comboBox1.Append("http://mobycentral.cbr.nrc.ca/cgi-bin/MOBY05/mobycentral.pl")
            
        try:
            fp=file("%s/.objectBrowser/.ns"%os.environ['HOME'])
            for l in fp.readlines():
                self.comboBox2.Append(l.replace("\n",""))
            fp.close()
        except:
            fp=file("%s/.objectBrowser/.ns"%os.environ['HOME'],"w")
            fp.write("http://mobycentral.cbr.nrc.ca/MOBY/Central")
            fp.close()
            self.comboBox2.Append("http://mobycentral.cbr.nrc.ca/MOBY/Central")
            
        
    def _feedNode(self, nodeName, node):
        
        if nodeName in self._otm.keys():
            for aNodeName in self._otm[nodeName]:
                aNode=self.OntologyTreeview.AppendItem(node, aNodeName)
                self._feedNode(aNodeName, aNode)

    def _getRelationships(self, node, listbox, relationship):
        text=self.OntologyTreeview.GetItemText(node)
        
        if relationship in self._otm.relations[text]:
            for r in self._otm.relations[text][relationship]:
                listbox.Append("%s->%s"%(r[0],r[1]))
                
        parent=self.OntologyTreeview.GetItemParent(node)
        if  parent != self.OntologyTreeview.GetRootItem():
            self._getRelationships(parent, listbox, relationship)

    def _treeClear(self):
        #self.OntologyTreeview.CollapseAndReset(self.OntologyTreeview.GetRootItem())
        self.OntologyTreeview.DeleteAllItems()
        
    def _infoClear(self):
        self.textCtrl1.SetValue("")
        self.textCtrl2.SetValue("")
        self.textCtrl3.SetValue("")
        self.listBox1.Clear()
        self.listBox2.Clear()
        self.listBox3.Clear()


    def OnOntologytreeviewTreeSelChanged(self, event):
        item=event.GetItem()
        text=self.OntologyTreeview.GetItemText(item)
        self._infoClear()
        
        if text in self._otm.definitions:
            self.textCtrl1.SetValue(self._otm.definitions[text]['Description'])
            self.textCtrl2.SetValue(self._otm.definitions[text]['contactEmail'])
            self.textCtrl3.SetValue(self._otm.definitions[text]['authURI'])
        
            self._getRelationships(item, self.listBox1, "HAS")
            
            self._getRelationships(item, self.listBox2, "HASA")
            
            for service in self._otm.inputServices[text]:
                self.listBox3.Append(service)

            for service in self._otm.outputServices[text]:
                self.listBox4.Append(service)

                
        event.Skip()

    def OnButton2Button(self, event):
        import wx
        self.gauge1.Show()
        wxBeginBusyCursor()
        
        fetchFromCache=self.checkBox1.GetValue()
        url=self.comboBox1.GetValue()
        ns=self.comboBox2.GetValue()

        m=md5.md5("%s+%s"%(url,ns))
        filename=m.hexdigest()
        
        if fetchFromCache:
            fp=file("%s/.objectBrowser/%s"%(os.environ['HOME'], filename))

            #try:
            self._otm=pickle.load(fp)
            #except:
            #    fetchFromCache=False
            fp.close()
            
        if not fetchFromCache:
            from bioMoby import Client
            client=Client(url=url, ns=ns)
            self._otm=OntologyTreeModel(client, setRange=self.gauge1.SetRange, setInc=self._makeProgress)
            fp=file("%s/.objectBrowser/%s"%(os.environ['HOME'], filename),"w")
            pickle.dump(self._otm, fp)
            fp.close()
            
        self._treeClear()
        self._infoClear()
        
        root=self.OntologyTreeview.AddRoot(url)
        self._feedNode('None', root)
        wxEndBusyCursor()
        self.gauge1.Hide()
        event.Skip()

    def OnButton1Button(self, event):
        self.Close()
        event.Skip()

    def _makeProgress(self):
        self.gauge1.SetValue(self.gauge1.GetValue()+1)
        wxYield()
        
class ObjectBrowser(wxApp):
    def OnInit(self):
        wxInitAllImageHandlers()
        self.main = wxFrame1(None)
        # needed when running from Boa under Windows 9X
        self.SetTopWindow(self.main)
        self.main.Show();self.main.Hide();self.main.Show()
        return True

if __name__ == '__main__':
    application = ObjectBrowser(0)
    application.MainLoop()
